#include <stdio.h>

#include "graph.h"

void usage(const char *progname) {
  fprintf(stderr, "Usage: %s <graph-input-file> \n", progname);
} // End usage()

int main(int argc, char *argv[]) {

  if(argc != 2) { usage(argv[0]); exit(1); }
  const char *graphFile = argv[1];

  graph_t g;
  fprintf(stderr, "Reading graphFile %s...\n", graphFile);
  g.readGraph(graphFile);
  
  bool bp = g.check_bipartite();
  cout << "The graph is bipartite? " << bp << "\n";

} // End main()
