#ifndef SATCOUNTER_H
#define SATCOUNTER_H

/** Defines a saturating counter */
class SatCounter {
 protected:
  int lower_limit;
  int upper_limit;

  int count;

 public:
  SatCounter() { count = lower_limit = upper_limit = 0; }
  SatCounter(int u_limit) {
    count = lower_limit = 0; upper_limit = u_limit;
  }
  SatCounter(int l_limit, int u_limit) {
    count = lower_limit = l_limit; upper_limit = u_limit;
  }

  void setLimits(int l_limit, int u_limit) {
    lower_limit = l_limit; upper_limit = u_limit;
  }

  void setCounter(int count_arg) { count = count_arg; }
  void set2lower() { count = lower_limit; }
  void set2upper() { count = upper_limit; }

  // Return success
  bool incr() {
    if(count < upper_limit) {
      count++; return true;
    } else {
      return false;
    }
  }

  // Return success
  bool decr() {
    if(count > lower_limit) {
      count--; return true;
    } else {
      return false;
    }
  }

  // Check against lower_limit
  bool isLower() { return (count == lower_limit); }
  // Check against upper_limit
  bool isUpper() { return (count == upper_limit); }
  
}; // End SatCounter

#endif
