#include "wp2p-phy.h"
#include "wp2p-ll.h"

static class WP2P_PhyClass : public TclClass {
public:
  WP2P_PhyClass() : TclClass("WP2P_PHY") {}
  TclObject* create(int /* argc */, const char*const* /* argv */) {
    return (new WP2P_PHY);
  }
} class_wp2p_phy;


int WP2P_PHY::command(int argc, const char*const* argv) {
  if (argc == 3) {
    if (strcmp(argv[1], "set-ll") == 0) {
      ll_ = (WP2P_LL*) TclObject::lookup(argv[2]);
      return (TCL_OK);
    }
  }

  return Connector::command(argc, argv);
} // End WP2P_PHY::command()


WP2P_PHY::WP2P_PHY() : Connector() {
  bind_bw("bandwidth_", &bandwidth_);
  bind_time("delay_", &delay_);
  count = 0;
} // End WP2P_PHY::WP2P_PHY()


void WP2P_PHY::recv(Packet* p, Handler* h) {
  double txt = txtime(p); // the transmission time
  Scheduler& s = Scheduler::instance();
  // target_ should be the MAC of the other side of the point-to-point
  // link
  HDR_CMN(p)->direction() = hdr_cmn::UP;
  HDR_CMN(p)->error() = ((count%10) == 0) ? 0 : 0;
/*  fprintf(stderr, "p-r %0.6f %d:%d seq=%d err=%d tcp_seq=%d\n", s.clock(),
	 ll_->my_id(), ll_->nbr_id(), get_seqno(p),
	  HDR_CMN(p)->error(), HDR_TCP(p)->seqno());*/
  count++;
  s.schedule(target_, p, txt + delay_);
} // End WP2P_PHY::recv()
