#!/usr/bin/perl

# Program to plot graphs of costs of various colouring algorithms

sub usage {
  print STDERR "Usage: $0 <col-num-for-sort-indexed-from-1>\n";
} # End usage()

($#ARGV == 0) || do { usage(); exit(1); };

my $sort_col_num = shift;
$sort_col_num--;

my @lines;
my $num_lines = 0;

while (my $line = <STDIN>) {
  chop($line);
  $line =~ s/\s+$//g;
  $lines[$num_lines] = $line;
  $num_lines++;
}

# Sort the list of lines
for (my $i = 0; $i < $num_lines; $i++) {

  for (my $j = $i+1; $j < $num_lines; $j++) {

    my @costs_i = split(/\s+/, $lines[$i]);
    my @costs_j = split(/\s+/, $lines[$j]);

    if ($costs_j[$sort_col_num] < $costs_i[$sort_col_num]) {
      my $temp_line = $lines[$i];
      $lines[$i] = $lines[$j];
      $lines[$j] = $temp_line;
    }

  }

}

# Print sorted lines onto STDOUT
for (my $i = 0; $i < $num_lines; $i++) {

  print STDOUT "$lines[$i]\n";

}
